/*
 * code simulant ce qu'un shell pourrait faire pour raliser  l'aide
 * de processus l'excution de la commande en ligne
 * $ cat f | grep 'a'
 * Les deux processus sont frres...
 */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

int main(int argc,char *argv[]) {
  pid_t premier_fils, second_fils;
  int tube[2];

  if (pipe(tube)==-1) {
    fprintf(stderr,"Impossible de creer le tube\n");
    exit(EXIT_FAILURE);
  }
  switch( premier_fils = fork() ) {
  case -1:
    fprintf(stderr,"Impossible de creer le premier processus fils\n");
    exit(EXIT_FAILURE);
  case 0:
    close(STDOUT_FILENO); /* fermeture de la sortie standard heritee */
    dup(tube[1]); /* clonage du tube cote ecriture dans la sortie standard */
    close(tube[0]); /* devenu inutile */
    close(tube[1]); /* devenu inutile */
    execlp("cat","cat","f",NULL); /* ok on recouvre par la bonne commande */
    exit(EXIT_FAILURE); /* bon rate c'est rate! */
  default:
    switch( second_fils=fork() ) {
    case -1:
      fprintf(stderr,"Impossible de creer le second fils\n");
      kill(SIGKILL,premier_fils); /* destruction du 1er fils devenu inutile! */
      waitpid(premier_fils,NULL,0); /* suppression du zombi ? */
      exit(EXIT_FAILURE);
    case 0:
      close(STDIN_FILENO); /* fermeture de l'entree standard */
      dup(tube[0]); /* clonage du tube cote lecture dans l'entree standard */
      close(tube[0]); /* devenu inutile */
      close(tube[1]); /* devenu inutile */
      execlp("grep","grep","a",NULL); /* ok on recouvre par la bonne commande */
      exit(EXIT_FAILURE); /* bon rate c'est rate! */
    default:
      close(tube[0]); /* devenu genant!!! sinon il reste un lecteur */
      close(tube[1]); /* devenu genant!!! sinon il reste un ecrivain et
		       grep ne finira jamais!!! */
      wait(NULL); /* on attend un fils */
      wait(NULL); /* puis l'autre, comme ca pas de zombi! */
      break;
    }
    break;
  }
  return EXIT_SUCCESS;
}
